/* Object Rexx (message operator is the tilde: ~), works with Java 1.1 too, 2003-05-10, 2005-06-05, 2006-01-06 */

/*
   license:

    ------------------------ Apache Version 2.0 license -------------------------
       Copyright (C) 2001-2006 Rony G. Flatscher

       Licensed under the Apache License, Version 2.0 (the "License");
       you may not use this file except in compliance with the License.
       You may obtain a copy of the License at

           http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing, software
       distributed under the License is distributed on an "AS IS" BASIS,
       WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
       See the License for the specific language governing permissions and
       limitations under the License.
    -----------------------------------------------------------------------------
*/
-- using rgf's sort utility package for Object Rexx, which runs on all
-- platforms (including e.g. OS/2)

-- system=.bsf4rexx~Class.class~forName("java.lang.System")  -- get the class object
system=.bsf~bsf.loadClass("java.lang.System")  -- get the class object

properties=system~getProperties     -- get the System properties
   -- this is another possibility to employ the BSF4Rexx utility class via the BSF-interface
enum=.bsf~bsf.wrapEnumeration( properties~propertyNames )    -- get an enumeration of the property names
key.=0
say copies("=", 70)
do i=1 to 9999 while enum~hasMoreElements       -- loop over enumeration
   key.i=enum~nextElement           -- get next element
end
key.0=i-1                             -- save # of stem array elements
say "key.0="key.0

arr=sort(key.)             -- now sort the stem, store sorted indices of stem in the array
do i=1 to arr~items
   say "key:" pp(left(arr[i], 30)) "value:" pp(properties~getProperty(arr[i]))
end


::requires BSF.CLS     -- get the Object Rexx support for bsf4rexx
::requires sort_util   -- get the sort utilities (works under OS/2 as well!)
                       -- <http://wi.wu-wien.ac.at/rgf/rexx/orx08> or one of the other "orx"-dirs

::routine pp   -- "cheap man's pretty print"
  return "[" || arg(1) || "]"

